gtkmm: Gtk::TextView Class Reference

gtkmm 4.23.2

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::TextView Class Reference
Widgets | Container Widgets | TextView Classes

Multi-line text editing widget. More...

`#include <gtkmm/textview.h>`

Inheritance diagram for Gtk::TextView:
[legend]

## Public Member Functions
| TextView (TextView && src) noexcept
TextView & | operator= (TextView && src) noexcept
| TextView (const TextView &)=delete
TextView & | operator= (const TextView &)=delete
| ~TextView () noexcept override
GtkTextView * | gobj ()
| Provides access to the underlying C GObject.
const GtkTextView * | gobj () const
| Provides access to the underlying C GObject.
| TextView ()
| TextView (const Glib::RefPtr< TextBuffer > & buffer)
void | set_buffer (const Glib::RefPtr< TextBuffer > & buffer)
| Sets buffer as the buffer being displayed by text_view.
Glib::RefPtr< TextBuffer > | get_buffer ()
| Returns the Gtk::TextBuffer being displayed by this text view.
Glib::RefPtr< const TextBuffer > | get_buffer () const
| Returns the Gtk::TextBuffer being displayed by this text view.
bool | scroll_to (TextBuffer::iterator & iter, double within_margin=0)
| Scrolls the TextView so that iter is on the screen, by scrolling the minimal distance to get the mark onscreen, possibly not scrolling at all.
bool | scroll_to (TextBuffer::iterator & iter, double within_margin, double xalign, double yalign)
| Scrolls the TextView so that iter is on the screen, in the position indicated by xalign and yalign, possibly not scrolling at all.
void | scroll_to (const Glib::RefPtr< TextBuffer::Mark > & mark, double within_margin=0)
| Scrolls text_view so that mark is on the screen, by scrolling the minimal distance to get the mark onscreen, possibly not scrolling at all.
void | scroll_to (const Glib::RefPtr< TextBuffer::Mark > & mark, double within_margin, double xalign, double yalign)
| Scrolls the TextView so that mark is on the screen, in the position indicated by xalign and yalign, possibly not scrolling at all.
bool | move_mark_onscreen (const Glib::RefPtr< TextBuffer::Mark > & mark)
| Moves a mark within the buffer so that it's located within the currently-visible text area.
bool | place_cursor_onscreen ()
| Moves the cursor to the currently visible region of the buffer.
void | get_visible_rect (Gdk::Rectangle & visible_rect) const
| Fills visible_rect with the currently-visible region of the buffer, in buffer coordinates.
std::pair< double, double > | get_visible_offset () const
| Gets the X,Y offset in buffer coordinates of the top-left corner of the textview's text contents.
void | set_cursor_visible (bool setting=true)
| Toggles whether the insertion point should be displayed.
bool | get_cursor_visible () const
| Find out whether the cursor should be displayed.
void | reset_cursor_blink ()
| Ensures that the cursor is shown.
void | get_cursor_locations (const TextBuffer::const_iterator & iter, Gdk::Rectangle & strong, Gdk::Rectangle & weak) const
| Determine the positions of the strong and weak cursors if the insertion point is at iter.
void | get_cursor_locations (Gdk::Rectangle & strong, Gdk::Rectangle & weak) const
| A get_cursor_locations() convenience overload.
void | get_iter_location (const TextBuffer::const_iterator & iter, Gdk::Rectangle & location) const
| Gets a rectangle which roughly contains the character at iter.
bool | get_iter_at_location (TextBuffer::iterator & iter, int x, int y)
| Retrieves the iterator at buffer coordinates x and y.
bool | get_iter_at_location (TextBuffer::const_iterator & iter, int x, int y) const
| Retrieves the iterator at buffer coordinates x and y.
bool | get_iter_at_position (TextBuffer::iterator & iter, int & trailing, int x, int y)
| Retrieves the iterator pointing to the character at buffer coordinates x and y.
bool | get_iter_at_position (TextBuffer::const_iterator & iter, int & trailing, int x, int y) const
| Retrieves the iterator pointing to the character at buffer coordinates x and y.
void | get_line_yrange (const TextBuffer::const_iterator & iter, int & y, int & height) const
| Gets the y coordinate of the top of the line containing iter, and the height of the line.
void | get_line_at_y (TextBuffer::iterator & target_iter, int y, int & line_top)
| Gets the Gtk::TextIter at the start of the line containing the coordinate y.
void | get_line_at_y (TextBuffer::const_iterator & target_iter, int y, int & line_top) const
| Gets the Gtk::TextIter at the start of the line containing the coordinate y.
void | buffer_to_window_coords (TextWindowType win, int buffer_x, int buffer_y, int & window_x, int & window_y) const
| Converts buffer coordinates to window coordinates.
void | window_to_buffer_coords (TextWindowType win, int window_x, int window_y, int & buffer_x, int & buffer_y) const
| Converts coordinates on the window identified by win to buffer coordinates.
bool | forward_display_line (TextBuffer::iterator & iter)
| Moves the given iter forward by one display (wrapped) line.
bool | backward_display_line (TextBuffer::iterator & iter)
| Moves the given iter backward by one display (wrapped) line.
bool | forward_display_line_end (TextBuffer::iterator & iter)
| Moves the given iter forward to the next display line end.
bool | backward_display_line_start (TextBuffer::iterator & iter)
| Moves the given iter backward to the next display line start.
bool | starts_display_line (const TextBuffer::iterator & iter)
| Determines whether iter is at the start of a display line.
bool | move_visually (TextBuffer::iterator & iter, int count)
| Move the iterator a given number of characters visually, treating it as the strong cursor position.
bool | im_context_filter_keypress (const Glib::RefPtr< Gdk::Event > & event)
| Allow the Gtk::TextView input method to internally handle key press and release events.
void | reset_im_context ()
| Reset the input method context of the text view if needed.
Widget * | get_gutter (TextWindowType win)
| Gets a Gtk::Widget that has previously been set as gutter.
const Widget * | get_gutter (TextWindowType win) const
| Gets a Gtk::Widget that has previously been set as gutter.
void | set_gutter (TextWindowType win, Widget & widget)
| Places widget into the gutter specified by win.
void | unset_gutter (TextWindowType win)
| Removes a widget from the gutter specified by win.
void | add_child_at_anchor (Widget & child, const Glib::RefPtr< TextBuffer::ChildAnchor > & anchor)
| Adds a child widget in the text buffer, at the given anchor.
void | add_overlay (Widget & child, int xpos, int ypos)
| Adds child at a fixed coordinate in the Gtk::TextView's text window.
void | move_overlay (Widget & child, int xpos, int ypos)
| Updates the position of a child.
void | remove (Widget & child)
| Removes a child widget from text_view.
void | set_wrap_mode (WrapMode wrap_mode)
| Sets the line wrapping for the view.
WrapMode | get_wrap_mode () const
| Gets the line wrapping for the view.
void | set_editable (bool setting=true)
| Sets the default editability of the Gtk::TextView.
bool | get_editable () const
| Returns the default editability of the Gtk::TextView.
void | set_pixels_above_lines (int pixels_above_lines)
| Sets the default number of blank pixels above paragraphs in text_view.
int | get_pixels_above_lines () const
| Gets the default number of pixels to put above paragraphs.
void | set_pixels_below_lines (int pixels_below_lines)
| Sets the default number of pixels of blank space to put below paragraphs in text_view.
int | get_pixels_below_lines () const
| Gets the default number of pixels to put below paragraphs.
void | set_pixels_inside_wrap (int pixels_inside_wrap)
| Sets the default number of pixels of blank space to leave between display/wrapped lines within a paragraph.
int | get_pixels_inside_wrap () const
| Gets the default number of pixels to put between wrapped lines inside a paragraph.
void | set_justification (Justification justification)
| Sets the default justification of text in text_view.
Justification | get_justification () const
| Gets the default justification of paragraphs in text_view.
void | set_left_margin (int left_margin)
| Sets the default left margin for text in text_view.
int | get_left_margin () const
| Gets the default left margin size of paragraphs in the text_view.
void | set_right_margin (int right_margin)
| Sets the default right margin for text in the text view.
int | get_right_margin () const
| Gets the default right margin for text in text_view.
void | set_top_margin (int top_margin)
| Sets the top margin for text in text_view.
int | get_top_margin () const
| Gets the top margin for text in the text_view.
void | set_bottom_margin (int bottom_margin)
| Sets the bottom margin for text in text_view.
int | get_bottom_margin () const
| Gets the bottom margin for text in the text_view.
void | set_indent (int indent)
| Sets the default indentation for paragraphs in text_view.
int | get_indent () const
| Gets the default indentation of paragraphs in text_view.
void | set_tabs (Pango::TabArray & tabs)
| Sets the default tab stops for paragraphs in text_view.
Pango::TabArray | get_tabs () const
| Gets the default tabs for text_view.
void | set_overwrite (bool overwrite=true)
| Changes the Gtk::TextView overwrite mode.
bool | get_overwrite () const
| Returns whether the Gtk::TextView is in overwrite mode or not.
void | set_accepts_tab (bool accepts_tab=true)
| Sets the behavior of the text widget when the `Tab` key is pressed.
bool | get_accepts_tab () const
| Returns whether pressing the `Tab` key inserts a tab characters.
void | set_input_purpose (InputPurpose purpose)
| Sets the input-purpose of the Gtk::TextView.
InputPurpose | get_input_purpose () const
| Gets the input-purpose of the Gtk::TextView.
void | set_input_hints (InputHints hints)
| Sets the input-hints of the Gtk::TextView.
InputHints | get_input_hints () const
| Gets the input-hints of the Gtk::TextView.
void | set_monospace (bool monospace=true)
| Sets whether the Gtk::TextView should display text in monospace styling.
bool | get_monospace () const
| Gets whether the Gtk::TextView uses monospace styling.
void | set_extra_menu (const Glib::RefPtr< Gio::MenuModel > & model)
| Sets a menu model to add when constructing the context menu for text_view.
Glib::RefPtr< Gio::MenuModel > | get_extra_menu ()
| Gets the menu model that gets added to the context menu or nullptr if none has been set.
Glib::RefPtr< const Gio::MenuModel > | get_extra_menu () const
| Gets the menu model that gets added to the context menu or nullptr if none has been set.
Glib::RefPtr< Pango::Context > | get_rtl_context ()
| Gets the Pango::Context that is used for rendering RTL directed text layouts.
Glib::RefPtr< const Pango::Context > | get_rtl_context () const
| Gets the Pango::Context that is used for rendering RTL directed text layouts.
Glib::RefPtr< Pango::Context > | get_ltr_context ()
| Gets the Pango::Context that is used for rendering LTR directed text layouts.
Glib::RefPtr< const Pango::Context > | get_ltr_context () const
| Gets the Pango::Context that is used for rendering LTR directed text layouts.
Glib::SignalProxy< void()> | signal_set_anchor ()
Glib::SignalProxy< void(const Glib::ustring &)> | signal_insert_at_cursor ()
Glib::PropertyProxy< int > | property_pixels_above_lines ()
| Pixels of blank space above paragraphs.
Glib::PropertyProxy_ReadOnly< int > | property_pixels_above_lines () const
| Pixels of blank space above paragraphs.
Glib::PropertyProxy< int > | property_pixels_below_lines ()
| Pixels of blank space below paragraphs.
Glib::PropertyProxy_ReadOnly< int > | property_pixels_below_lines () const
| Pixels of blank space below paragraphs.
Glib::PropertyProxy< int > | property_pixels_inside_wrap ()
| Pixels of blank space between wrapped lines in a paragraph.
Glib::PropertyProxy_ReadOnly< int > | property_pixels_inside_wrap () const
| Pixels of blank space between wrapped lines in a paragraph.
Glib::PropertyProxy< bool > | property_editable ()
| Whether the text can be modified by the user.
Glib::PropertyProxy_ReadOnly< bool > | property_editable () const
| Whether the text can be modified by the user.
Glib::PropertyProxy< WrapMode > | property_wrap_mode ()
| Whether to wrap lines never, at word boundaries, or at character boundaries.
Glib::PropertyProxy_ReadOnly< WrapMode > | property_wrap_mode () const
| Whether to wrap lines never, at word boundaries, or at character boundaries.
Glib::PropertyProxy< Justification > | property_justification ()
| Left, right, or center justification.
Glib::PropertyProxy_ReadOnly< Justification > | property_justification () const
| Left, right, or center justification.
Glib::PropertyProxy< int > | property_left_margin ()
| The default left margin for text in the text view.
Glib::PropertyProxy_ReadOnly< int > | property_left_margin () const
| The default left margin for text in the text view.
Glib::PropertyProxy< int > | property_right_margin ()
| The default right margin for text in the text view.
Glib::PropertyProxy_ReadOnly< int > | property_right_margin () const
| The default right margin for text in the text view.
Glib::PropertyProxy< int > | property_top_margin ()
| The top margin for text in the text view.
Glib::PropertyProxy_ReadOnly< int > | property_top_margin () const
| The top margin for text in the text view.
Glib::PropertyProxy< int > | property_bottom_margin ()
| The bottom margin for text in the text view.
Glib::PropertyProxy_ReadOnly< int > | property_bottom_margin () const
| The bottom margin for text in the text view.
Glib::PropertyProxy< int > | property_indent ()
| Amount to indent the paragraph, in pixels.
Glib::PropertyProxy_ReadOnly< int > | property_indent () const
| Amount to indent the paragraph, in pixels.
Glib::PropertyProxy< Pango::TabArray > | property_tabs ()
| Custom tabs for this text.
Glib::PropertyProxy_ReadOnly< Pango::TabArray > | property_tabs () const
| Custom tabs for this text.
Glib::PropertyProxy< bool > | property_cursor_visible ()
| If the insertion cursor is shown.
Glib::PropertyProxy_ReadOnly< bool > | property_cursor_visible () const
| If the insertion cursor is shown.
Glib::PropertyProxy< Glib::RefPtr< TextBuffer > > | property_buffer ()
| The buffer which is displayed.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TextBuffer > > | property_buffer () const
| The buffer which is displayed.
Glib::PropertyProxy< bool > | property_overwrite ()
| Whether entered text overwrites existing contents.
Glib::PropertyProxy_ReadOnly< bool > | property_overwrite () const
| Whether entered text overwrites existing contents.
Glib::PropertyProxy< bool > | property_accepts_tab ()
| Whether Tab will result in a tab character being entered.
Glib::PropertyProxy_ReadOnly< bool > | property_accepts_tab () const
| Whether Tab will result in a tab character being entered.
Glib::PropertyProxy< Glib::ustring > | property_im_module ()
| Which IM (input method) module should be used for this text_view.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_im_module () const
| Which IM (input method) module should be used for this text_view.
Glib::PropertyProxy< InputPurpose > | property_input_purpose ()
| The purpose of this text field.
Glib::PropertyProxy_ReadOnly< InputPurpose > | property_input_purpose () const
| The purpose of this text field.
Glib::PropertyProxy< InputHints > | property_input_hints ()
| Additional hints (beyond property_input_purpose()) that allow input methods to fine-tune their behaviour.
Glib::PropertyProxy_ReadOnly< InputHints > | property_input_hints () const
| Additional hints (beyond property_input_purpose()) that allow input methods to fine-tune their behaviour.
Glib::PropertyProxy< bool > | property_monospace ()
| Whether text should be displayed in a monospace font.
Glib::PropertyProxy_ReadOnly< bool > | property_monospace () const
| Whether text should be displayed in a monospace font.
Glib::PropertyProxy< Glib::RefPtr< Gio::MenuModel > > | property_extra_menu ()
| A menu model whose contents will be appended to the context menu.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::MenuModel > > | property_extra_menu () const
| A menu model whose contents will be appended to the context menu.
Public Member Functions inherited from Gtk::Widget
| Widget (Widget && src) noexcept
Widget & | operator= (Widget && src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget.
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget.
void | show ()
| Flags a widget to be displayed.
void | hide ()
| Reverses the effects of [method.Gtk.Widget.show].
void | queue_draw ()
| Schedules this widget to be redrawn.
void | queue_resize ()
| Flags a widget to have its size renegotiated.
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function.
void | size_allocate (const Allocation & allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size.
Measurements | measure (Orientation orientation, int for_size=-1) const
| Like the other overload of measure() but returns a structure holding the sizes/baselines instead of using output parameters.
void | get_preferred_size (Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
PreferredSize | get_preferred_size () const
| Like the other overload of get_preferred_size() but returns a structure holding the sizes instead of using output parameters.
void | set_layout_manager (const Glib::RefPtr< LayoutManager > & layout_manager)
| Sets the layout manager to use for measuring and allocating children of the widget.
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager().
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager of the widget.
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager of the widget.
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | set_can_focus (bool can_focus=true)
| Sets whether the input focus can enter the widget or any of its children.
bool | get_can_focus () const
| Determines whether the input focus can enter the widget or any of its children.
void | set_focusable (bool focusable=true)
| Sets whether the widget can own the input focus.
bool | get_focusable () const
| Determines whether the widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
bool | grab_focus ()
| Causes widget to have the keyboard focus for the window that it belongs to.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_target (bool can_target=true)
| Sets whether the widget can be the target of pointer events.
bool | get_can_target () const
| Queries whether the widget can be the target of pointer events.
bool | has_default () const
| Determines whether the widget is the current default widget within its toplevel.
void | set_receives_default (bool receives_default=true)
| Sets whether the widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether the widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
void | set_name (const Glib::ustring & name)
| Sets a widgets name.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state.
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of the widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity.
bool | is_sensitive () const
| Returns the widget’s effective sensitivity.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | is_drawable () const
| Determines whether the widget can be drawn to.
bool | get_realized () const
| Determines whether the widget is realized.
bool | get_mapped () const
| Returns whether the widget is mapped.
void | set_child_visible (bool visible=true)
| Sets whether the widget should be mapped along with its parent.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
int | get_allocated_width () const
| Returns the width that has currently been allocated to the widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to the widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to the widget.
Allocation | get_allocation () const
| Retrieves the widget’s location.
std::optional< Gdk::Graphene::Rect > | compute_bounds (const Widget & target) const
| Computes the bounds for the widget in the coordinate space of target.
std::optional< Gdk::Graphene::Point > | compute_point (const Widget & target, const Gdk::Graphene::Point & point) const
| Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.
int | get_width () const
| Returns the content width of the widget.
int | get_height () const
| Returns the content height of the widget.
int | get_baseline () const
| Returns the baseline that has currently been allocated to the widget.
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget.
Widget * | get_parent ()
| Returns the parent widget of the widget.
const Widget * | get_parent () const
| Returns the parent widget of the widget.
Root * | get_root ()
| Returns the Gtk::Root widget of the widget.
const Root * | get_root () const
| Returns the Gtk::Root widget of the widget.
Native * | get_native ()
| Returns the nearest Gtk::Native ancestor of the widget.
const Native * | get_native () const
| Returns the nearest Gtk::Native ancestor of the widget.
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts.
bool | keynav_failed (DirectionType direction)
| Emits the signal_keynav_failed() signal on the widget.
void | error_bell ()
| Notifies the user about an input-related error on the widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of the widget.
void | get_size_request (int & width, int & height) const
| Gets the size request that was explicitly set for the widget.
Requisition | get_size_request () const
| Like the other overload of get_size_request() but returns a structure holding the sizes instead of using output parameters.
void | set_opacity (double opacity)
| Requests the widget to be rendered partially transparent.
double | get_opacity () const
| Fetches the requested opacity for the widget.
void | set_overflow (Overflow overflow)
| Sets how the widget treats content that is drawn outside the it's content area.
Overflow | get_overflow () const
| Returns the widget’s overflow value.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of the widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of the widget with type widget_type.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the display for the window that the widget belongs to.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the display for the window that the widget belongs to.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for the widget.
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of the widget.
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of the widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether the hexpand flag has been explicitly set.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether the vexpand flag has been explicitly set.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used.
bool | compute_expand (Orientation orientation)
| Computes whether a parent widget should give this widget extra space when possible.
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions.
Align | get_halign () const
| Gets the horizontal alignment of the widget.
void | set_halign (Align align)
| Sets the horizontal alignment of the widget.
Align | get_valign () const
| Gets the vertical alignment of the widget.
void | set_valign (Align align)
| Sets the vertical alignment of the widget.
int | get_margin_start () const
| Gets the start margin of the widget.
void | set_margin_start (int margin)
| Sets the start margin of the widget.
int | get_margin_end () const
| Gets the end margin of the widget.
void | set_margin_end (int margin)
| Sets the end margin of the widget.
int | get_margin_top () const
| Gets the top margin of the widget.
void | set_margin_top (int margin)
| Sets the top margin of the widget.
int | get_margin_bottom () const
| Gets the bottom margin of the widget.
void | set_margin_bottom (int margin)
| Sets the bottom margin of the widget.
void | set_margin (int margin)
| Set all 4 margins to the same value.
bool | is_ancestor (Widget & ancestor) const
| Determines whether the widget is a descendent of ancestor.
bool | translate_coordinates (Widget & dest_widget, double src_x, double src_y, double & dest_x, double & dest_y)
| Translates coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
bool | contains (double x, double y) const
| Tests if a given point is contained in the widget.
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of the widget closest to a point.
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of the widget closest to a point.
void | add_controller (const Glib::RefPtr< EventController > & controller)
| Adds an event controller to the widget.
void | remove_controller (const Glib::RefPtr< EventController > & controller)
| Removes an event controller from the widget.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context that is configured for the widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context that is configured for the widget.
void | set_font_options (const Cairo::FontOptions & options)
| Sets the cairo_font_options_t used for text rendering in the widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
Cairo::FontOptions | get_font_options () const
| Returns the cairo_font_options_t of the widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring & text)
| Creates a new Pango::Layout that is configured for the widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on the widget.
TextDirection | get_direction () const
| Gets the reading direction for the widget.
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > & cursor)
| Sets the cursor to be shown when the pointer hovers over the widget.
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget.
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Gets the cursor set on the widget.
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Gets the cursor set on the widget.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic.
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic.
void | add_mnemonic_label (Widget & label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget & label)
| Removes a widget from the list of mnemonic labels for this widget.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
void | set_parent (Widget & parent)
| Sets the parent widget of the widget.
void | unparent ()
| Removes widget from its parent.
void | map ()
| Causes a widget to be mapped if it isn’t already.
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display of the widget.
void | set_tooltip_text (const Glib::ustring & text)
| Sets the contents of the tooltip for the widget.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for the widget.
void | set_tooltip_markup (const Glib::ustring & markup)
| Sets the contents of the tooltip for widget.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for the widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on the widget.
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to the widget.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to the widget.
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts an action group into the widget's actions.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase & args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it.
void | activate_default ()
| Activates the default.activate action for the widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > & font_map)
| Sets the font map to use for text rendering in the widget.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of the widget.
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of the widget.
Widget * | get_first_child ()
| Returns the widget’s first child.
const Widget * | get_first_child () const
| Returns the widget’s first child.
Widget * | get_last_child ()
| Returns the widget’s last child.
const Widget * | get_last_child () const
| Returns the widget’s last child.
Widget * | get_next_sibling ()
| Returns the widget’s next sibling.
const Widget * | get_next_sibling () const
| Returns the widget’s next sibling.
Widget * | get_prev_sibling ()
| Returns the widget’s previous sibling.
const Widget * | get_prev_sibling () const
| Returns the widget’s previous sibling.
std::vector< Widget * > | get_children ()
| Gets a vector of the widgetʼs current children, from first child to last.
std::vector< const Widget * > | get_children () const
| Gets a vector of the widgetʼs current children, from first child to last.
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a list model to track the children of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a list model to track the children of the widget.
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a list model to track the event controllers of the widget.
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a list model to track the event controllers of the widget.
void | insert_after (Widget & parent, const Widget & previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling.
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling.
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent.
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent.
void | snapshot_child (Widget & child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshots a child of the widget.
bool | should_layout () const
| Returns whether the widget should contribute to the measuring and allocation of its parent.
Glib::ustring | get_css_name () const
| Returns the CSS name of the widget.
void | add_css_class (const Glib::ustring & css_class)
| Adds a style class to the widget.
void | remove_css_class (const Glib::ustring & css_class)
| Removes a style from the widget.
bool | has_css_class (const Glib::ustring & css_class) const
| Returns whether a style class is currently applied to the widget.
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to the widget.
void | set_css_classes (const std::vector< Glib::ustring > & classes)
| Replaces the current style classes of the widget with classes.
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style.
void | set_limit_events (bool limit_events=true)
| Sets whether the widget acts like a modal dialog, with respect to event delivery.
bool | get_limit_events () const
| Gets the value of the property_limit_events() property.
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase.
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The Gtk::Root widget of the widget tree containing this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Overrides for width request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Overrides for width request of the widget.
Glib::PropertyProxy< int > | property_height_request ()
| Overrides for height request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Overrides for height request of the widget.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events.
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the hexpand property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the hexpand property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the vexpand property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the vexpand property.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree.
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget.
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy< bool > | property_limit_events ()
| Makes this widget act like a modal dialog, with respect to event delivery.
Glib::PropertyProxy_ReadOnly< bool > | property_limit_events () const
| Makes this widget act like a modal dialog, with respect to event delivery.
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible && src) noexcept
Accessible & | operator= (Accessible && src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject.
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the implementation for the given accessible object.
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the implementation for the given accessible object.
bool | get_platform_state (PlatformState state) const
| Queries a platform state, such as focus.
void | update_platform_state (PlatformState state)
| Informs ATs that the platform state has changed.
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object.
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object.
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > & next_sibling)
| Sets the parent and sibling of an accessible object.
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object.
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object.
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > & new_sibling)
| Updates the next accessible sibling.
bool | get_bounds (int & x, int & y, int & width, int & height) const
| Queries the coordinates and dimensions of this accessible.
Glib::ustring | get_accessible_id () const
| Retrieves the accessible identifier for the accessible object.
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object.
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state.
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property.
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation.
void | reset_state (State state)
| Resets the accessible state to its default value.
void | reset_property (Property property)
| Resets the accessible property to its default value.
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value.
void | announce (const Glib::ustring & message, AnnouncementPriority priority)
| Requests the user's screen reader to announce the given message.
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given Gtk::Accessible implementation.
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given Gtk::Accessible implementation.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget && src) noexcept
ConstraintTarget & | operator= (ConstraintTarget && src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject.
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Gtk::Scrollable
| Scrollable (Scrollable && src) noexcept
Scrollable & | operator= (Scrollable && src) noexcept
| ~Scrollable () noexcept override
GtkScrollable * | gobj ()
| Provides access to the underlying C GObject.
const GtkScrollable * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< Adjustment > | get_hadjustment ()
| Retrieves the Gtk::Adjustment used for horizontal scrolling.
Glib::RefPtr< const Adjustment > | get_hadjustment () const
| Retrieves the Gtk::Adjustment used for horizontal scrolling.
void | set_hadjustment (const Glib::RefPtr< Adjustment > & hadjustment)
| Sets the horizontal adjustment of the Gtk::Scrollable.
void | unset_hadjustment ()
| This method removes the hadjustment.
Glib::RefPtr< Adjustment > | get_vadjustment ()
| Retrieves the Gtk::Adjustment used for vertical scrolling.
Glib::RefPtr< const Adjustment > | get_vadjustment () const
| Retrieves the Gtk::Adjustment used for vertical scrolling.
void | set_vadjustment (const Glib::RefPtr< Adjustment > & vadjustment)
| Sets the vertical adjustment of the Gtk::Scrollable.
void | unset_vadjustment ()
| This method removes the vadjustment.
Policy | get_hscroll_policy () const
| Gets the horizontal Gtk::Scrollable::Policy.
void | set_hscroll_policy (Policy policy)
| Sets the Gtk::Scrollable::Policy.
Policy | get_vscroll_policy () const
| Gets the vertical Gtk::Scrollable::Policy.
void | set_vscroll_policy (Policy policy)
| Sets the Gtk::Scrollable::Policy.
bool | get_border (Border & border) const
| Returns the size of a non-scrolling border around the outside of the scrollable.
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_hadjustment ()
| Horizontal Gtk::Adjustment of the scrollable widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_hadjustment () const
| Horizontal Gtk::Adjustment of the scrollable widget.
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_vadjustment ()
| Vertical Gtk::Adjustment of the scrollable widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_vadjustment () const
| Vertical Gtk::Adjustment of the scrollable widget.
Glib::PropertyProxy< Policy > | property_hscroll_policy ()
| Determines when horizontal scrolling should start.
Glib::PropertyProxy_ReadOnly< Policy > | property_hscroll_policy () const
| Determines when horizontal scrolling should start.
Glib::PropertyProxy< Policy > | property_vscroll_policy ()
| Determines when vertical scrolling should start.
Glib::PropertyProxy_ReadOnly< Policy > | property_vscroll_policy () const
| Determines when vertical scrolling should start.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets.
static TextDirection | get_default_direction ()
| Obtains the default reading direction.
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Scrollable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
virtual void | on_set_anchor ()
| This is a default handler for the signal signal_set_anchor().
virtual void | on_insert_at_cursor (const Glib::ustring & str)
| This is a default handler for the signal signal_insert_at_cursor().
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget * child)
| Sets the focused child of widget.
virtual void | compute_expand_vfunc (bool & hexpand_p, bool & vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget.
void | unrealize ()
| Causes a widget to be unrealized.
void | realize_if_needed ()
void | set_focus_child (Widget & child)
| Set the focus child of the widget.
void | unset_focus_child ()
| Unsets the focus child of the widget.
Widget * | get_focus_child ()
| Returns the focus child of the widget.
const Widget * | get_focus_child () const
| Returns the focus child of the widget.
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > & tooltip)
| This is a default handler for the signal signal_query_tooltip().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Scrollable
| Scrollable ()
| You should derive from this class to use it.
virtual bool | get_border_vfunc (Border & border) const

## Related Symbols
(Note that these are not member symbols.)
Gtk::TextView * | wrap (GtkTextView * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Scrollable
Glib::RefPtr< Gtk::Scrollable > | wrap (GtkScrollable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Gtk::Widget
using | PreferredSize = MinimumNatural<Requisition>
| Structure returned by the non-output-parameter overload of get_preferred_size().
using | SlotTick = sigc::slot<bool(const Glib::RefPtr<Gdk::FrameClock>&)>
| Callback type for adding a function to update animations.
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::Accessible
enum class | Role { Role::ALERT , Role::ALERT_DIALOG , Role::BANNER , Role::BUTTON , Role::CAPTION , Role::CELL , Role::CHECKBOX , Role::COLUMN_HEADER , Role::COMBO_BOX , Role::COMMAND , Role::COMPOSITE , Role::DIALOG , Role::DOCUMENT , Role::FEED , Role::FORM , Role::GENERIC , Role::GRID , Role::GRID_CELL , Role::GROUP , Role::HEADING , Role::IMG , Role::INPUT , Role::LABEL , Role::LANDMARK , Role::LEGEND , Role::LINK , Role::LIST , Role::LIST_BOX , Role::LIST_ITEM , Role::LOG , Role::MAIN , Role::MARQUEE , Role::MATH , Role::METER , Role::MENU , Role::MENU_BAR , Role::MENU_ITEM , Role::MENU_ITEM_CHECKBOX , Role::MENU_ITEM_RADIO , Role::NAVIGATION , Role::NONE , Role::NOTE , Role::OPTION , Role::PRESENTATION , Role::PROGRESS_BAR , Role::RADIO , Role::RADIO_GROUP , Role::RANGE , Role::REGION , Role::ROW , Role::ROW_GROUP , Role::ROW_HEADER , Role::SCROLLBAR , Role::SEARCH , Role::SEARCH_BOX , Role::SECTION , Role::SECTION_HEAD , Role::SELECT , Role::SEPARATOR , Role::SLIDER , Role::SPIN_BUTTON , Role::STATUS , Role::STRUCTURE , Role::SWITCH , Role::TAB , Role::TABLE , Role::TAB_LIST , Role::TAB_PANEL , Role::TEXT_BOX , Role::TIME , Role::TIMER , Role::TOOLBAR , Role::TOOLTIP , Role::TREE , Role::TREE_GRID , Role::TREE_ITEM , Role::WIDGET , Role::WINDOW , Role::TOGGLE_BUTTON , Role::APPLICATION , Role::PARAGRAPH , Role::BLOCK_QUOTE , Role::ARTICLE , Role::COMMENT , Role::TERMINAL }
| The accessible role for a Gtk::Accessible implementation. More...
enum class | State { State::BUSY , State::CHECKED , State::DISABLED , State::EXPANDED , State::HIDDEN , State::INVALID , State::PRESSED , State::SELECTED , State::VISITED }
| The possible accessible states of a Gtk::Accessible. More...
enum class | Property { Property::AUTOCOMPLETE , Property::DESCRIPTION , Property::HAS_POPUP , Property::KEY_SHORTCUTS , Property::LABEL , Property::LEVEL , Property::MODAL , Property::MULTI_LINE , Property::MULTI_SELECTABLE , Property::ORIENTATION , Property::PLACEHOLDER , Property::READ_ONLY , Property::REQUIRED , Property::ROLE_DESCRIPTION , Property::SORT , Property::VALUE_MAX , Property::VALUE_MIN , Property::VALUE_NOW , Property::VALUE_TEXT , Property::HELP_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum class | Relation { Relation::ACTIVE_DESCENDANT , Relation::COL_COUNT , Relation::COL_INDEX , Relation::COL_INDEX_TEXT , Relation::COL_SPAN , Relation::CONTROLS , Relation::DESCRIBED_BY , Relation::DETAILS , Relation::ERROR_MESSAGE , Relation::FLOW_TO , Relation::LABELLED_BY , Relation::OWNS , Relation::POS_IN_SET , Relation::ROW_COUNT , Relation::ROW_INDEX , Relation::ROW_INDEX_TEXT , Relation::ROW_SPAN , Relation::SET_SIZE , Relation::LABEL_FOR , Relation::DESCRIPTION_FOR , Relation::CONTROLLED_BY , Relation::DETAILS_FOR , Relation::ERROR_MESSAGE_FOR , Relation::FLOW_FROM }
| The possible accessible relations of a Gtk::Accessible. More...
enum class | PlatformState { PlatformState::FOCUSABLE , PlatformState::FOCUSED , PlatformState::ACTIVE }
| The various platform states which can be queried using Gtk::Accessible::get_platform_state(). More...
enum class | AnnouncementPriority { AnnouncementPriority::LOW , AnnouncementPriority::MEDIUM , AnnouncementPriority::HIGH }
| The priority of an accessibility announcement. More...
Public Types inherited from Gtk::Scrollable
enum class | Policy { Policy::MINIMUM , Policy::NATURAL }
| Defines the policy to be used in a scrollable widget when updating the scrolled window adjustments in a given orientation. More...

## Detailed Description

Multi-line text editing widget.

It displays a Gtk::TextBuffer.

The TextView widget looks like this:

## Constructor & Destructor Documentation

## ◆ TextView() [1/4]

Gtk::TextView::TextView | ( | TextView && | src | ) |
| noexcept

## ◆ TextView() [2/4]

Gtk::TextView::TextView | ( | const TextView & |  | ) |
| delete

## ◆ ~TextView()

Gtk::TextView::~TextView | ( |  | ) |
| overridenoexcept

## ◆ TextView() [3/4]

Gtk::TextView::TextView | ( |  | ) |

## ◆ TextView() [4/4]

Gtk::TextView::TextView | ( | const Glib::RefPtr< TextBuffer > & | buffer | ) |
| explicit

## Member Function Documentation

## ◆ add_child_at_anchor()

void Gtk::TextView::add_child_at_anchor | ( | Widget & | child,
|  | const Glib::RefPtr< TextBuffer::ChildAnchor > & | anchor )

Adds a child widget in the text buffer, at the given anchor.

Parameters

  child | A Gtk::Widget.
  anchor | A Gtk::TextChildAnchor in the Gtk::TextBuffer for text_view.

## ◆ add_overlay()

void Gtk::TextView::add_overlay | ( | Widget & | child,
|  | int | xpos,
|  | int | ypos )

Adds child at a fixed coordinate in the Gtk::TextView's text window.

The xpos and ypos must be in buffer coordinates (see get_iter_location() to convert to buffer coordinates).

child will scroll with the text view.

If instead you want a widget that will not move with the Gtk::TextView contents see Gtk::Overlay.

Parameters

  child | A Gtk::Widget.
  xpos | X position of child in window coordinates.
  ypos | Y position of child in window coordinates.

## ◆ backward_display_line()

bool Gtk::TextView::backward_display_line | ( | TextBuffer::iterator & | iter | ) |

Moves the given iter backward by one display (wrapped) line.

A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view’s width; paragraphs are the same in all views, since they depend on the contents of the Gtk::TextBuffer.

Parameters

  iter | A Gtk::TextIter.

Returns
  true if iter was moved and is not on the end iterator.

## ◆ backward_display_line_start()

bool Gtk::TextView::backward_display_line_start | ( | TextBuffer::iterator & | iter | ) |

Moves the given iter backward to the next display line start.

A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view’s width; paragraphs are the same in all views, since they depend on the contents of the Gtk::TextBuffer.

Parameters

  iter | A Gtk::TextIter.

Returns
  true if iter was moved and is not on the end iterator.

## ◆ buffer_to_window_coords()

void Gtk::TextView::buffer_to_window_coords | ( | TextWindowType | win,
|  | int | buffer_x,
|  | int | buffer_y,
|  | int & | window_x,
|  | int & | window_y ) const

Converts buffer coordinates to window coordinates.

Parameters

  win | A Gtk::TextWindowType.
  buffer_x | Buffer x coordinate.
  buffer_y | Buffer y coordinate.
  window_x | Window x coordinate return location.
  window_y | Window y coordinate return location.

## ◆ forward_display_line()

bool Gtk::TextView::forward_display_line | ( | TextBuffer::iterator & | iter | ) |

Moves the given iter forward by one display (wrapped) line.

A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view’s width; paragraphs are the same in all views, since they depend on the contents of the Gtk::TextBuffer.

Parameters

  iter | A Gtk::TextIter.

Returns
  true if iter was moved and is not on the end iterator.

## ◆ forward_display_line_end()

bool Gtk::TextView::forward_display_line_end | ( | TextBuffer::iterator & | iter | ) |

Moves the given iter forward to the next display line end.

A display line is different from a paragraph. Paragraphs are separated by newlines or other paragraph separator characters. Display lines are created by line-wrapping a paragraph. If wrapping is turned off, display lines and paragraphs will be the same. Display lines are divided differently for each view, since they depend on the view’s width; paragraphs are the same in all views, since they depend on the contents of the Gtk::TextBuffer.

Parameters

  iter | A Gtk::TextIter.

Returns
  true if iter was moved and is not on the end iterator.

## ◆ get_accepts_tab()

bool Gtk::TextView::get_accepts_tab | ( |  | ) | const

Returns whether pressing the `Tab` key inserts a tab characters.

See set_accepts_tab().

Returns
  true if pressing the Tab key inserts a tab character, false if pressing the Tab key moves the keyboard focus.

## ◆ get_bottom_margin()

int Gtk::TextView::get_bottom_margin | ( |  | ) | const

Gets the bottom margin for text in the text_view.

Since gtkmm 3.20

Returns
  Bottom margin in pixels.

## ◆ get_buffer() [1/2]

Glib::RefPtr< TextBuffer > Gtk::TextView::get_buffer | ( |  | ) |

Returns the Gtk::TextBuffer being displayed by this text view.

The reference count on the buffer is not incremented; the caller of this function won’t own a new reference.

Returns
  A Gtk::TextBuffer.

## ◆ get_buffer() [2/2]

Glib::RefPtr< const TextBuffer > Gtk::TextView::get_buffer | ( |  | ) | const

Returns the Gtk::TextBuffer being displayed by this text view.

The reference count on the buffer is not incremented; the caller of this function won’t own a new reference.

Returns
  A Gtk::TextBuffer.

## ◆ get_cursor_locations() [1/2]

void Gtk::TextView::get_cursor_locations | ( | const TextBuffer::const_iterator & | iter,
|  | Gdk::Rectangle & | strong,
|  | Gdk::Rectangle & | weak ) const

Determine the positions of the strong and weak cursors if the insertion point is at iter.

The position of each cursor is stored as a zero-width rectangle. The strong cursor location is the location where characters of the directionality equal to the base direction of the paragraph are inserted. The weak cursor location is the location where characters of the directionality opposite to the base direction of the paragraph are inserted.

If iter is nullptr, the actual cursor position is used.

Note that if iter happens to be the actual cursor position, and there is currently an IM preedit sequence being entered, the returned locations will be adjusted to account for the preedit cursor’s offset within the preedit sequence.

The rectangle position is in buffer coordinates; use buffer_to_window_coords() to convert these coordinates to coordinates for one of the windows in the text view.

Parameters

  iter | A Gtk::TextIter.
  strong | Location to store the strong cursor position.
  weak | Location to store the weak cursor position.

## ◆ get_cursor_locations() [2/2]

void Gtk::TextView::get_cursor_locations | ( | Gdk::Rectangle & | strong,
|  | Gdk::Rectangle & | weak ) const

A get_cursor_locations() convenience overload.

## ◆ get_cursor_visible()

bool Gtk::TextView::get_cursor_visible | ( |  | ) | const

Find out whether the cursor should be displayed.

Returns
  Whether the insertion mark is visible.

## ◆ get_editable()

bool Gtk::TextView::get_editable | ( |  | ) | const

Returns the default editability of the Gtk::TextView.

Tags in the buffer may override this setting for some ranges of text.

Returns
  Whether text is editable by default.

## ◆ get_extra_menu() [1/2]

Glib::RefPtr< Gio::MenuModel > Gtk::TextView::get_extra_menu | ( |  | ) |

Gets the menu model that gets added to the context menu or nullptr if none has been set.

Returns
  The menu model.

## ◆ get_extra_menu() [2/2]

Glib::RefPtr< const Gio::MenuModel > Gtk::TextView::get_extra_menu | ( |  | ) | const

Gets the menu model that gets added to the context menu or nullptr if none has been set.

Returns
  The menu model.

## ◆ get_gutter() [1/2]

Widget * Gtk::TextView::get_gutter | ( | TextWindowType | win | ) |

Gets a Gtk::Widget that has previously been set as gutter.

See set_gutter().

win must be one of Gtk::TextWindowType::LEFT, Gtk::TextWindowType::RIGHT, Gtk::TextWindowType::TOP, or Gtk::TextWindowType::BOTTOM.

Parameters

  win | A Gtk::TextWindowType.

Returns
  A Gtk::Widget.

## ◆ get_gutter() [2/2]

const Widget * Gtk::TextView::get_gutter | ( | TextWindowType | win | ) | const

Gets a Gtk::Widget that has previously been set as gutter.

See set_gutter().

win must be one of Gtk::TextWindowType::LEFT, Gtk::TextWindowType::RIGHT, Gtk::TextWindowType::TOP, or Gtk::TextWindowType::BOTTOM.

Parameters

  win | A Gtk::TextWindowType.

Returns
  A Gtk::Widget.

## ◆ get_indent()

int Gtk::TextView::get_indent | ( |  | ) | const

Gets the default indentation of paragraphs in text_view.

Tags in the view’s buffer may override the default. The indentation may be negative.

Returns
  Number of pixels of indentation.

## ◆ get_input_hints()

InputHints Gtk::TextView::get_input_hints | ( |  | ) | const

Gets the input-hints of the Gtk::TextView.

Returns
  The input hints.

## ◆ get_input_purpose()

InputPurpose Gtk::TextView::get_input_purpose | ( |  | ) | const

Gets the input-purpose of the Gtk::TextView.

Returns
  The input purpose.

## ◆ get_iter_at_location() [1/2]

bool Gtk::TextView::get_iter_at_location | ( | TextBuffer::const_iterator & | iter,
|  | int | x,
|  | int | y ) const

Retrieves the iterator at buffer coordinates x and y.

Buffer coordinates are coordinates for the entire buffer, not just the currently-displayed portion. If you have coordinates from an event, you have to convert those to buffer coordinates with window_to_buffer_coords().

Parameters

  iter | A Gtk::TextIter.
  x | X position, in buffer coordinates.
  y | Y position, in buffer coordinates.

Returns
  true if the position is over text.

## ◆ get_iter_at_location() [2/2]

bool Gtk::TextView::get_iter_at_location | ( | TextBuffer::iterator & | iter,
|  | int | x,
|  | int | y )

Retrieves the iterator at buffer coordinates x and y.

Buffer coordinates are coordinates for the entire buffer, not just the currently-displayed portion. If you have coordinates from an event, you have to convert those to buffer coordinates with window_to_buffer_coords().

Parameters

  iter | A Gtk::TextIter.
  x | X position, in buffer coordinates.
  y | Y position, in buffer coordinates.

Returns
  true if the position is over text.

## ◆ get_iter_at_position() [1/2]

bool Gtk::TextView::get_iter_at_position | ( | TextBuffer::const_iterator & | iter,
|  | int & | trailing,
|  | int | x,
|  | int | y ) const

Retrieves the iterator pointing to the character at buffer coordinates x and y.

Buffer coordinates are coordinates for the entire buffer, not just the currently-displayed portion. If you have coordinates from an event, you have to convert those to buffer coordinates with window_to_buffer_coords().

Note that this is different from get_iter_at_location(), which returns cursor locations, i.e. positions between characters.

Parameters

  iter | A Gtk::TextIter.
  trailing | If non-nullptr, location to store an integer indicating where in the grapheme the user clicked. It will either be zero, or the number of characters in the grapheme. 0 represents the trailing edge of the grapheme.
  x | X position, in buffer coordinates.
  y | Y position, in buffer coordinates.

Returns
  true if the position is over text.

## ◆ get_iter_at_position() [2/2]

bool Gtk::TextView::get_iter_at_position | ( | TextBuffer::iterator & | iter,
|  | int & | trailing,
|  | int | x,
|  | int | y )

Retrieves the iterator pointing to the character at buffer coordinates x and y.

Buffer coordinates are coordinates for the entire buffer, not just the currently-displayed portion. If you have coordinates from an event, you have to convert those to buffer coordinates with window_to_buffer_coords().

Note that this is different from get_iter_at_location(), which returns cursor locations, i.e. positions between characters.

Parameters

  iter | A Gtk::TextIter.
  trailing | If non-nullptr, location to store an integer indicating where in the grapheme the user clicked. It will either be zero, or the number of characters in the grapheme. 0 represents the trailing edge of the grapheme.
  x | X position, in buffer coordinates.
  y | Y position, in buffer coordinates.

Returns
  true if the position is over text.

## ◆ get_iter_location()

void Gtk::TextView::get_iter_location | ( | const TextBuffer::const_iterator & | iter,
|  | Gdk::Rectangle & | location ) const

Gets a rectangle which roughly contains the character at iter.

The rectangle position is in buffer coordinates; use buffer_to_window_coords() to convert these coordinates to coordinates for one of the windows in the text view.

Parameters

  iter | A Gtk::TextIter.
  location | Bounds of the character at iter.

## ◆ get_justification()

Justification Gtk::TextView::get_justification | ( |  | ) | const

Gets the default justification of paragraphs in text_view.

Tags in the buffer may override the default.

Returns
  Default justification.

## ◆ get_left_margin()

int Gtk::TextView::get_left_margin | ( |  | ) | const

Gets the default left margin size of paragraphs in the text_view.

Tags in the buffer may override the default.

Returns
  Left margin in pixels.

## ◆ get_line_at_y() [1/2]

void Gtk::TextView::get_line_at_y | ( | TextBuffer::const_iterator & | target_iter,
|  | int | y,
|  | int & | line_top ) const

Gets the Gtk::TextIter at the start of the line containing the coordinate y.

y is in buffer coordinates, convert from window coordinates with window_to_buffer_coords(). If non-nullptr, line_top will be filled with the coordinate of the top edge of the line.

Parameters

  target_iter | A Gtk::TextIter.
  y | A y coordinate.
  line_top | Return location for top coordinate of the line.

## ◆ get_line_at_y() [2/2]

void Gtk::TextView::get_line_at_y | ( | TextBuffer::iterator & | target_iter,
|  | int | y,
|  | int & | line_top )

Gets the Gtk::TextIter at the start of the line containing the coordinate y.

y is in buffer coordinates, convert from window coordinates with window_to_buffer_coords(). If non-nullptr, line_top will be filled with the coordinate of the top edge of the line.

Parameters

  target_iter | A Gtk::TextIter.
  y | A y coordinate.
  line_top | Return location for top coordinate of the line.

## ◆ get_line_yrange()

void Gtk::TextView::get_line_yrange | ( | const TextBuffer::const_iterator & | iter,
|  | int & | y,
|  | int & | height ) const

Gets the y coordinate of the top of the line containing iter, and the height of the line.

The coordinate is a buffer coordinate; convert to window coordinates with buffer_to_window_coords().

Parameters

  iter | A Gtk::TextIter.
  y | Return location for a y coordinate.
  height | Return location for a height.

## ◆ get_ltr_context() [1/2]

Glib::RefPtr< Pango::Context > Gtk::TextView::get_ltr_context | ( |  | ) |

Gets the Pango::Context that is used for rendering LTR directed text layouts.

The context may be replaced when CSS changes occur.

Since gtkmm 4.4

Returns
  A Pango::Context.

## ◆ get_ltr_context() [2/2]

Glib::RefPtr< const Pango::Context > Gtk::TextView::get_ltr_context | ( |  | ) | const

Gets the Pango::Context that is used for rendering LTR directed text layouts.

The context may be replaced when CSS changes occur.

Since gtkmm 4.4

Returns
  A Pango::Context.

## ◆ get_monospace()

bool Gtk::TextView::get_monospace | ( |  | ) | const

Gets whether the Gtk::TextView uses monospace styling.

Return: true if monospace fonts are desired

## ◆ get_overwrite()

bool Gtk::TextView::get_overwrite | ( |  | ) | const

Returns whether the Gtk::TextView is in overwrite mode or not.

Returns
  Whether text_view is in overwrite mode or not.

## ◆ get_pixels_above_lines()

int Gtk::TextView::get_pixels_above_lines | ( |  | ) | const

Gets the default number of pixels to put above paragraphs.

Adding this function with get_pixels_below_lines() is equal to the line space between each paragraph.

Returns
  Default number of pixels above paragraphs.

## ◆ get_pixels_below_lines()

int Gtk::TextView::get_pixels_below_lines | ( |  | ) | const

Gets the default number of pixels to put below paragraphs.

The line space is the sum of the value returned by this function and the value returned by get_pixels_above_lines().

Returns
  Default number of blank pixels below paragraphs.

## ◆ get_pixels_inside_wrap()

int Gtk::TextView::get_pixels_inside_wrap | ( |  | ) | const

Gets the default number of pixels to put between wrapped lines inside a paragraph.

Returns
  Default number of pixels of blank space between wrapped lines.

## ◆ get_right_margin()

int Gtk::TextView::get_right_margin | ( |  | ) | const

Gets the default right margin for text in text_view.

Tags in the buffer may override the default.

Returns
  Right margin in pixels.

## ◆ get_rtl_context() [1/2]

Glib::RefPtr< Pango::Context > Gtk::TextView::get_rtl_context | ( |  | ) |

Gets the Pango::Context that is used for rendering RTL directed text layouts.

The context may be replaced when CSS changes occur.

Since gtkmm 4.4

Returns
  A Pango::Context.

## ◆ get_rtl_context() [2/2]

Glib::RefPtr< const Pango::Context > Gtk::TextView::get_rtl_context | ( |  | ) | const

Gets the Pango::Context that is used for rendering RTL directed text layouts.

The context may be replaced when CSS changes occur.

Since gtkmm 4.4

Returns
  A Pango::Context.

## ◆ get_tabs()

Pango::TabArray Gtk::TextView::get_tabs | ( |  | ) | const

Gets the default tabs for text_view.

Tags in the buffer may override the defaults. The returned array will be empty if "standard" (8-space) tabs are used.

Returns
  Copy of default tab array, or an empty array if "standard" tabs are used.

## ◆ get_top_margin()

int Gtk::TextView::get_top_margin | ( |  | ) | const

Gets the top margin for text in the text_view.

Since gtkmm 3.20

Returns
  Top margin in pixels.

## ◆ get_type()

GType Gtk::TextView::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_visible_offset()

std::pair< double, double > Gtk::TextView::get_visible_offset | ( |  | ) | const

Gets the X,Y offset in buffer coordinates of the top-left corner of the textview's text contents.

This allows for more-precise positioning than what is provided by get_visible_rect() as you can discover what device pixel is being quantized for text positioning.

You might want this when making ulterior widgets align with quantized device pixels of the textview contents such as line numbers.

Since gtkmm 4.18

Returns
  {x_offset, y_offset} X offset and Y offset.

## ◆ get_visible_rect()

void Gtk::TextView::get_visible_rect | ( | Gdk::Rectangle & | visible_rect | ) | const

Fills visible_rect with the currently-visible region of the buffer, in buffer coordinates.

Convert to window coordinates with buffer_to_window_coords().

Parameters

  visible_rect | Rectangle to fill.

## ◆ get_wrap_mode()

WrapMode Gtk::TextView::get_wrap_mode | ( |  | ) | const

Gets the line wrapping for the view.

Returns
  The line wrap setting.

## ◆ gobj() [1/2]

GtkTextView * Gtk::TextView::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkTextView * Gtk::TextView::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ im_context_filter_keypress()

bool Gtk::TextView::im_context_filter_keypress | ( | const Glib::RefPtr< Gdk::Event > & | event | ) |

Allow the Gtk::TextView input method to internally handle key press and release events.

If this function returns true, then no further processing should be done for this key event. See Gtk::IMContext::filter_keypress().

Note that you are expected to call this function from your handler when overriding key event handling. This is needed in the case when you need to insert your own key handling between the input method and the default key event handling of the Gtk::TextView.

[C example ellipted]

Parameters

  event | The key event.

Returns
  true if the input method handled the key event.

## ◆ move_mark_onscreen()

bool Gtk::TextView::move_mark_onscreen | ( | const Glib::RefPtr< TextBuffer::Mark > & | mark | ) |

Moves a mark within the buffer so that it's located within the currently-visible text area.

Parameters

  mark | A Gtk::TextMark.

Returns
  true if the mark moved (wasn’t already onscreen).

## ◆ move_overlay()

void Gtk::TextView::move_overlay | ( | Widget & | child,
|  | int | xpos,
|  | int | ypos )

Updates the position of a child.

See add_overlay().

Parameters

  child | A widget already added with add_overlay().
  xpos | New X position in buffer coordinates.
  ypos | New Y position in buffer coordinates.

## ◆ move_visually()

bool Gtk::TextView::move_visually | ( | TextBuffer::iterator & | iter,
|  | int | count )

Move the iterator a given number of characters visually, treating it as the strong cursor position.

If count is positive, then the new strong cursor position will be count positions to the right of the old cursor position. If count is negative then the new strong cursor position will be count positions to the left of the old cursor position.

In the presence of bi-directional text, the correspondence between logical and visual order will depend on the direction of the current run, and there may be jumps when the cursor is moved off of the end of a run.

Parameters

  iter | A Gtk::TextIter.
  count | Number of characters to move (negative moves left, positive moves right).

Returns
  true if iter moved and is not on the end iterator.

## ◆ on_insert_at_cursor()

virtual void Gtk::TextView::on_insert_at_cursor | ( | const Glib::ustring & | str | ) |
| protectedvirtual

This is a default handler for the signal signal_insert_at_cursor().

## ◆ on_set_anchor()

virtual void Gtk::TextView::on_set_anchor | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_set_anchor().

## ◆ operator=() [1/2]

TextView & Gtk::TextView::operator= | ( | const TextView & |  | ) |
| delete

## ◆ operator=() [2/2]

TextView & Gtk::TextView::operator= | ( | TextView && | src | ) |
| noexcept

## ◆ place_cursor_onscreen()

bool Gtk::TextView::place_cursor_onscreen | ( |  | ) |

Moves the cursor to the currently visible region of the buffer.

Returns
  true if the cursor had to be moved.

## ◆ property_accepts_tab() [1/2]

Glib::PropertyProxy< bool > Gtk::TextView::property_accepts_tab | ( |  | ) |

Whether Tab will result in a tab character being entered.

Default value: true

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_accepts_tab() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextView::property_accepts_tab | ( |  | ) | const

Whether Tab will result in a tab character being entered.

Default value: true

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_bottom_margin() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_bottom_margin | ( |  | ) |

The bottom margin for text in the text view.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Don't confuse this property with Gtk::Widget::property_margin_bottom().

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_bottom_margin() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_bottom_margin | ( |  | ) | const

The bottom margin for text in the text view.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Don't confuse this property with Gtk::Widget::property_margin_bottom().

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_buffer() [1/2]

Glib::PropertyProxy< Glib::RefPtr< TextBuffer > > Gtk::TextView::property_buffer | ( |  | ) |

The buffer which is displayed.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_buffer() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< TextBuffer > > Gtk::TextView::property_buffer | ( |  | ) | const

The buffer which is displayed.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_cursor_visible() [1/2]

Glib::PropertyProxy< bool > Gtk::TextView::property_cursor_visible | ( |  | ) |

If the insertion cursor is shown.

Default value: true

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_cursor_visible() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextView::property_cursor_visible | ( |  | ) | const

If the insertion cursor is shown.

Default value: true

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_editable() [1/2]

Glib::PropertyProxy< bool > Gtk::TextView::property_editable | ( |  | ) |

Whether the text can be modified by the user.

Default value: true

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_editable() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextView::property_editable | ( |  | ) | const

Whether the text can be modified by the user.

Default value: true

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_extra_menu() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Gio::MenuModel > > Gtk::TextView::property_extra_menu | ( |  | ) |

A menu model whose contents will be appended to the context menu.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_extra_menu() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::MenuModel > > Gtk::TextView::property_extra_menu | ( |  | ) | const

A menu model whose contents will be appended to the context menu.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_im_module() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::TextView::property_im_module | ( |  | ) |

Which IM (input method) module should be used for this text_view.

See Gtk::IMMulticontext.

Setting this to a non-nullptr value overrides the system-wide IM module setting. See the GtkSettings Gtk::Settings::property_gtk_im_module() property.

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_im_module() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::TextView::property_im_module | ( |  | ) | const

Which IM (input method) module should be used for this text_view.

See Gtk::IMMulticontext.

Setting this to a non-nullptr value overrides the system-wide IM module setting. See the GtkSettings Gtk::Settings::property_gtk_im_module() property.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_indent() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_indent | ( |  | ) |

Amount to indent the paragraph, in pixels.

A negative value of indent will produce a hanging indentation. That is, the first line will have the full width, and subsequent lines will be indented by the absolute value of indent.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_indent() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_indent | ( |  | ) | const

Amount to indent the paragraph, in pixels.

A negative value of indent will produce a hanging indentation. That is, the first line will have the full width, and subsequent lines will be indented by the absolute value of indent.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_input_hints() [1/2]

Glib::PropertyProxy< InputHints > Gtk::TextView::property_input_hints | ( |  | ) |

Additional hints (beyond property_input_purpose()) that allow input methods to fine-tune their behaviour.

Default value: Gtk::InputHints::NONE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_input_hints() [2/2]

Glib::PropertyProxy_ReadOnly< InputHints > Gtk::TextView::property_input_hints | ( |  | ) | const

Additional hints (beyond property_input_purpose()) that allow input methods to fine-tune their behaviour.

Default value: Gtk::InputHints::NONE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_input_purpose() [1/2]

Glib::PropertyProxy< InputPurpose > Gtk::TextView::property_input_purpose | ( |  | ) |

The purpose of this text field.

This property can be used by on-screen keyboards and other input methods to adjust their behaviour.

Default value: Gtk::InputPurpose::FREE_FORM

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_input_purpose() [2/2]

Glib::PropertyProxy_ReadOnly< InputPurpose > Gtk::TextView::property_input_purpose | ( |  | ) | const

The purpose of this text field.

This property can be used by on-screen keyboards and other input methods to adjust their behaviour.

Default value: Gtk::InputPurpose::FREE_FORM

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_justification() [1/2]

Glib::PropertyProxy< Justification > Gtk::TextView::property_justification | ( |  | ) |

Left, right, or center justification.

Default value: Gtk::Justification::LEFT

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_justification() [2/2]

Glib::PropertyProxy_ReadOnly< Justification > Gtk::TextView::property_justification | ( |  | ) | const

Left, right, or center justification.

Default value: Gtk::Justification::LEFT

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_left_margin() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_left_margin | ( |  | ) |

The default left margin for text in the text view.

Tags in the buffer may override the default.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_left_margin() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_left_margin | ( |  | ) | const

The default left margin for text in the text view.

Tags in the buffer may override the default.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_monospace() [1/2]

Glib::PropertyProxy< bool > Gtk::TextView::property_monospace | ( |  | ) |

Whether text should be displayed in a monospace font.

If true, set the .monospace style class on the text view to indicate that a monospace font is desired.

Default value: false

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_monospace() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextView::property_monospace | ( |  | ) | const

Whether text should be displayed in a monospace font.

If true, set the .monospace style class on the text view to indicate that a monospace font is desired.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_overwrite() [1/2]

Glib::PropertyProxy< bool > Gtk::TextView::property_overwrite | ( |  | ) |

Whether entered text overwrites existing contents.

Default value: false

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_overwrite() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::TextView::property_overwrite | ( |  | ) | const

Whether entered text overwrites existing contents.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_above_lines() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_pixels_above_lines | ( |  | ) |

Pixels of blank space above paragraphs.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_above_lines() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_pixels_above_lines | ( |  | ) | const

Pixels of blank space above paragraphs.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_below_lines() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_pixels_below_lines | ( |  | ) |

Pixels of blank space below paragraphs.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_below_lines() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_pixels_below_lines | ( |  | ) | const

Pixels of blank space below paragraphs.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_inside_wrap() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_pixels_inside_wrap | ( |  | ) |

Pixels of blank space between wrapped lines in a paragraph.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_pixels_inside_wrap() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_pixels_inside_wrap | ( |  | ) | const

Pixels of blank space between wrapped lines in a paragraph.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_right_margin() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_right_margin | ( |  | ) |

The default right margin for text in the text view.

Tags in the buffer may override the default.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_right_margin() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_right_margin | ( |  | ) | const

The default right margin for text in the text view.

Tags in the buffer may override the default.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_tabs() [1/2]

Glib::PropertyProxy< Pango::TabArray > Gtk::TextView::property_tabs | ( |  | ) |

Custom tabs for this text.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_tabs() [2/2]

Glib::PropertyProxy_ReadOnly< Pango::TabArray > Gtk::TextView::property_tabs | ( |  | ) | const

Custom tabs for this text.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_top_margin() [1/2]

Glib::PropertyProxy< int > Gtk::TextView::property_top_margin | ( |  | ) |

The top margin for text in the text view.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Don't confuse this property with Gtk::Widget::property_margin_top().

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_top_margin() [2/2]

Glib::PropertyProxy_ReadOnly< int > Gtk::TextView::property_top_margin | ( |  | ) | const

The top margin for text in the text view.

Note that this property is confusingly named. In CSS terms, the value set here is padding, and it is applied in addition to the padding from the theme.

Don't confuse this property with Gtk::Widget::property_margin_top().

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_wrap_mode() [1/2]

Glib::PropertyProxy< WrapMode > Gtk::TextView::property_wrap_mode | ( |  | ) |

Whether to wrap lines never, at word boundaries, or at character boundaries.

Default value: Gtk::WrapMode::NONE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_wrap_mode() [2/2]

Glib::PropertyProxy_ReadOnly< WrapMode > Gtk::TextView::property_wrap_mode | ( |  | ) | const

Whether to wrap lines never, at word boundaries, or at character boundaries.

Default value: Gtk::WrapMode::NONE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ remove()

void Gtk::TextView::remove | ( | Widget & | child | ) |

Removes a child widget from text_view.

Parameters

  child | The child to remove.

## ◆ reset_cursor_blink()

void Gtk::TextView::reset_cursor_blink | ( |  | ) |

Ensures that the cursor is shown.

This also resets the time that it will stay blinking (or visible, in case blinking is disabled).

This function should be called in response to user input (e.g. from derived classes that override the textview's event handlers).

## ◆ reset_im_context()

void Gtk::TextView::reset_im_context | ( |  | ) |

Reset the input method context of the text view if needed.

This can be necessary in the case where modifying the buffer would confuse on-going input method behavior.

## ◆ scroll_to() [1/4]

void Gtk::TextView::scroll_to | ( | const Glib::RefPtr< TextBuffer::Mark > & | mark,
|  | double | within_margin,
|  | double | xalign,
|  | double | yalign )

Scrolls the TextView so that mark is on the screen, in the position indicated by xalign and yalign, possibly not scrolling at all.

The effective screen for purposes of this function is reduced by a margin of size within_margin.

Parameters

  mark | An mark pointing to the position that should be made visible by scrolling.
  within_margin | margin as a [0.0,0.5] fraction of screen size.
  xalign | horizontal alignment of mark within visible area. An alignment of 0.0 indicates left, 1.0 indicates right, 0.5 means center.
  yalign | vertical alignment of mark within visible area. An alignment of 0.0 indicates top, 1.0 indicates bottom, 0.5 means center.

## ◆ scroll_to() [2/4]

void Gtk::TextView::scroll_to | ( | const Glib::RefPtr< TextBuffer::Mark > & | mark,
|  | double | within_margin = 0 )

Scrolls text_view so that mark is on the screen, by scrolling the minimal distance to get the mark onscreen, possibly not scrolling at all.

The effective screen for purposes of this function is reduced by a margin of size within_margin.

Parameters

  mark | An mark pointing to the position that should be made visible by scrolling.
  within_margin | margin as a [0.0,0.5] fraction of screen size.

## ◆ scroll_to() [3/4]

bool Gtk::TextView::scroll_to | ( | TextBuffer::iterator & | iter,
|  | double | within_margin,
|  | double | xalign,
|  | double | yalign )

Scrolls the TextView so that iter is on the screen, in the position indicated by xalign and yalign, possibly not scrolling at all.

The effective screen for purposes of this function is reduced by a margin of size within_margin.

Note
  This function uses the currently-computed height of the lines in the text buffer. Note that line heights are computed in an idle handler; so this function may not have the desired effect if it's called before the height computations. To avoid oddness, consider using gtk_text_view_scroll_to_mark() which saves a point to be scrolled to after line validation.

Parameters

  iter | An iterator pointing to the position that should be made visible by scrolling.
  within_margin | margin as a [0.0,0.5] fraction of screen size.
  xalign | horizontal alignment of mark within visible area. An alignment of 0.0 indicates left, 1.0 indicates right, 0.5 means center.
  yalign | vertical alignment of mark within visible area. An alignment of 0.0 indicates top, 1.0 indicates bottom, 0.5 means center.

Returns
  true if scrolling occurred.

## ◆ scroll_to() [4/4]

bool Gtk::TextView::scroll_to | ( | TextBuffer::iterator & | iter,
|  | double | within_margin = 0 )

Scrolls the TextView so that iter is on the screen, by scrolling the minimal distance to get the mark onscreen, possibly not scrolling at all.

The effective screen for purposes of this function is reduced by a margin of size within_margin.

Note
  This function uses the currently-computed height of the lines in the text buffer. Note that line heights are computed in an idle handler; so this function may not have the desired effect if it's called before the height computations. To avoid oddness, consider using gtk_text_view_scroll_to_mark() which saves a point to be scrolled to after line validation.

Parameters

  iter | An iterator pointing to the position that should be made visible by scrolling.
  within_margin | margin as a [0.0,0.5] fraction of screen size.

Returns
  true if scrolling occurred.

## ◆ set_accepts_tab()

void Gtk::TextView::set_accepts_tab | ( | bool | accepts_tab = true | ) |

Sets the behavior of the text widget when the `Tab` key is pressed.

If accepts_tab is true, a tab character is inserted. If accepts_tab is false the keyboard focus is moved to the next widget in the focus chain.

Focus can always be moved using `Ctrl`+`Tab`.

Parameters

  accepts_tab | true if pressing the Tab key should insert a tab character, false, if pressing the Tab key should move the keyboard focus.

## ◆ set_bottom_margin()

void Gtk::TextView::set_bottom_margin | ( | int | bottom_margin | ) |

Sets the bottom margin for text in text_view.

Note that this function is confusingly named. In CSS terms, the value set here is padding.

Since gtkmm 3.20

Parameters

  bottom_margin | Bottom margin in pixels.

## ◆ set_buffer()

void Gtk::TextView::set_buffer | ( | const Glib::RefPtr< TextBuffer > & | buffer | ) |

Sets buffer as the buffer being displayed by text_view.

The previous buffer displayed by the text view is unreferenced, and a reference is added to buffer. If you owned a reference to buffer before passing it to this function, you must remove that reference yourself; Gtk::TextView will not “adopt” it.

Parameters

  buffer | A Gtk::TextBuffer.

## ◆ set_cursor_visible()

void Gtk::TextView::set_cursor_visible | ( | bool | setting = true | ) |

Toggles whether the insertion point should be displayed.

A buffer with no editable text probably shouldn’t have a visible cursor, so you may want to turn the cursor off.

Note that this property may be overridden by the Gtk::Settings::property_gtk_keynav_use_caret() setting.

Parameters

  setting | Whether to show the insertion cursor.

## ◆ set_editable()

void Gtk::TextView::set_editable | ( | bool | setting = true | ) |

Sets the default editability of the Gtk::TextView.

You can override this default setting with tags in the buffer, using the “editable” attribute of tags.

Parameters

  setting | Whether it’s editable.

## ◆ set_extra_menu()

void Gtk::TextView::set_extra_menu | ( | const Glib::RefPtr< Gio::MenuModel > & | model | ) |

Sets a menu model to add when constructing the context menu for text_view.

You can pass nullptr to remove a previously set extra menu.

Parameters

  model | A Gio::MenuModel.

## ◆ set_gutter()

void Gtk::TextView::set_gutter | ( | TextWindowType | win,
|  | Widget & | widget )

Places widget into the gutter specified by win.

win must be one of Gtk::TextWindowType::LEFT, Gtk::TextWindowType::RIGHT, Gtk::TextWindowType::TOP, or Gtk::TextWindowType::BOTTOM.

Parameters

  win | A Gtk::TextWindowType.
  widget | A Gtk::Widget.

## ◆ set_indent()

void Gtk::TextView::set_indent | ( | int | indent | ) |

Sets the default indentation for paragraphs in text_view.

Tags in the buffer may override the default.

Parameters

  indent | Indentation in pixels.

## ◆ set_input_hints()

void Gtk::TextView::set_input_hints | ( | InputHints | hints | ) |

Sets the input-hints of the Gtk::TextView.

The input-hints allow input methods to fine-tune their behaviour.

Parameters

  hints | The hints.

## ◆ set_input_purpose()

void Gtk::TextView::set_input_purpose | ( | InputPurpose | purpose | ) |

Sets the input-purpose of the Gtk::TextView.

The input-purpose can be used by on-screen keyboards and other input methods to adjust their behaviour.

Parameters

  purpose | The purpose.

## ◆ set_justification()

void Gtk::TextView::set_justification | ( | Justification | justification | ) |

Sets the default justification of text in text_view.

Tags in the view’s buffer may override the default.

Parameters

  justification | Justification.

## ◆ set_left_margin()

void Gtk::TextView::set_left_margin | ( | int | left_margin | ) |

Sets the default left margin for text in text_view.

Tags in the buffer may override the default.

Note that this function is confusingly named. In CSS terms, the value set here is padding.

Parameters

  left_margin | Left margin in pixels.

## ◆ set_monospace()

void Gtk::TextView::set_monospace | ( | bool | monospace = true | ) |

Sets whether the Gtk::TextView should display text in monospace styling.

Parameters

  monospace | true to request monospace styling.

## ◆ set_overwrite()

void Gtk::TextView::set_overwrite | ( | bool | overwrite = true | ) |

Changes the Gtk::TextView overwrite mode.

Parameters

  overwrite | true to turn on overwrite mode, false to turn it off.

## ◆ set_pixels_above_lines()

void Gtk::TextView::set_pixels_above_lines | ( | int | pixels_above_lines | ) |

Sets the default number of blank pixels above paragraphs in text_view.

Tags in the buffer for text_view may override the defaults.

Parameters

  pixels_above_lines | Pixels above paragraphs.

## ◆ set_pixels_below_lines()

void Gtk::TextView::set_pixels_below_lines | ( | int | pixels_below_lines | ) |

Sets the default number of pixels of blank space to put below paragraphs in text_view.

May be overridden by tags applied to text_view’s buffer.

Parameters

  pixels_below_lines | Pixels below paragraphs.

## ◆ set_pixels_inside_wrap()

void Gtk::TextView::set_pixels_inside_wrap | ( | int | pixels_inside_wrap | ) |

Sets the default number of pixels of blank space to leave between display/wrapped lines within a paragraph.

May be overridden by tags in text_view’s buffer.

Parameters

  pixels_inside_wrap | Default number of pixels between wrapped lines.

## ◆ set_right_margin()

void Gtk::TextView::set_right_margin | ( | int | right_margin | ) |

Sets the default right margin for text in the text view.

Tags in the buffer may override the default.

Note that this function is confusingly named. In CSS terms, the value set here is padding.

Parameters

  right_margin | Right margin in pixels.

## ◆ set_tabs()

void Gtk::TextView::set_tabs | ( | Pango::TabArray & | tabs | ) |

Sets the default tab stops for paragraphs in text_view.

Tags in the buffer may override the default.

Parameters

  tabs | Tabs as a Pango::TabArray.

## ◆ set_top_margin()

void Gtk::TextView::set_top_margin | ( | int | top_margin | ) |

Sets the top margin for text in text_view.

Note that this function is confusingly named. In CSS terms, the value set here is padding.

Since gtkmm 3.20

Parameters

  top_margin | Top margin in pixels.

## ◆ set_wrap_mode()

void Gtk::TextView::set_wrap_mode | ( | WrapMode | wrap_mode | ) |

Sets the line wrapping for the view.

Parameters

  wrap_mode | A Gtk::WrapMode.

## ◆ signal_insert_at_cursor()

Glib::SignalProxy< void(const Glib::ustring &)> Gtk::TextView::signal_insert_at_cursor | ( |  | ) |

Slot Prototype:
  void on_my_insert_at_cursor(const Glib::ustring& str)

Flags: Run Last, Action

Gets emitted when the user initiates the insertion of a fixed string at the cursor.

The signal_insert_at_cursor() signal is a keybinding signal.

This signal has no default bindings.

Parameters

  str | The string to insert.

## ◆ signal_set_anchor()

Glib::SignalProxy< void()> Gtk::TextView::signal_set_anchor | ( |  | ) |

Slot Prototype:
  void on_my_set_anchor()

Flags: Run Last, Action

Gets emitted when the user initiates settings the "anchor" mark.

The signal_set_anchor() signal is a keybinding signal which gets emitted when the user initiates setting the "anchor" mark. The "anchor" mark gets placed at the same position as the "insert" mark.

This signal has no default bindings.

## ◆ starts_display_line()

bool Gtk::TextView::starts_display_line | ( | const TextBuffer::iterator & | iter | ) |

Determines whether iter is at the start of a display line.

See forward_display_line() for an explanation of display lines vs. paragraphs.

Parameters

  iter | A Gtk::TextIter.

Returns
  true if iter begins a wrapped line.

## ◆ unset_gutter()

void Gtk::TextView::unset_gutter | ( | TextWindowType | win | ) |

Removes a widget from the gutter specified by win.

win must be one of Gtk::TextWindowType::LEFT, Gtk::TextWindowType::RIGHT, Gtk::TextWindowType::TOP, or Gtk::TextWindowType::BOTTOM.

Parameters

  win | A Gtk::TextWindowType.

## ◆ window_to_buffer_coords()

void Gtk::TextView::window_to_buffer_coords | ( | TextWindowType | win,
|  | int | window_x,
|  | int | window_y,
|  | int & | buffer_x,
|  | int & | buffer_y ) const

Converts coordinates on the window identified by win to buffer coordinates.

Parameters

  win | A Gtk::TextWindowType.
  window_x | Window x coordinate.
  window_y | Window y coordinate.
  buffer_x | Buffer x coordinate return location.
  buffer_y | Buffer y coordinate return location.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::TextView * wrap | ( | GtkTextView * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.